#include "../../internal-include/CD/cd_internal.hpp"
#include <PSX/Audio/CDDA.hpp>
#include <stdio.hpp>

namespace JabyEngine {
    namespace CDDA {
        namespace CD = JabyEngine::CD::internal;

        TrackList get_tracks() {
            CD::Command::wait_completed();

            CD_IO::PortIndex0::change_to();
            CD::Command::send_wait<CD_IO::PortIndex0>(CD_IO::Command::GetTN);
            
            const auto stat       = CD_IO::PortIndex0::ResponseFifo.read();
            const auto first      = CD_IO::PortIndex0::ResponseFifo.read().raw;
            const auto end        = CD_IO::PortIndex0::ResponseFifo.read().raw;
            const auto last_track = (end - first) + 1;

            if(last_track == 1) {
                return TrackList::empty();
            }

            return TrackList{.first_track = 2, .last_track = static_cast<uint8_t>(last_track)};
        }

        void play(uint8_t track) {
            CD::enable_CDDA(); // < Command waits
            CD::Command::send<CD_IO::PortIndex0>(CD_IO::Command::Play, track);
        }

        void pause() {
            CD::Command::wait_completed();
            CD::Command::send<CD_IO::PortIndex0>(CD_IO::Command::Pause);
        }
    }
}